-- BigRender by Rakete GmbH / info@rakete.de
global defWidth=renderWidth
global defHeight=renderHeight
global defPath=pathConfig.removePathLeaf rendOutputFilename
global defFname=pathConfig.stripPathToLeaf rendOutputFilename

global initRenderValues
global updateButtonState

callbacks.addScript #renderParamsChanged "initRenderValues()"

rollout Tilespane "Choose tiles" width:250 height:100 rolledUp (

fn updateButtonState state = (

	-- disable all
	for i=1 to 36 do (
	Tilespane.controls[i].caption=""
	Tilespane.controls[i].checked=true
	Tilespane.controls[i].enabled=false
	Tilespane.controls[i].visible=false
	)

	numtiles=state*state
	cap=0
	for i=1 to state do (
		for t=1 to state do (
			cap=cap+1
			curTile=(i-1)*6+(t)
			Tilespane.controls[curTile].enabled=true
			Tilespane.controls[curTile].caption=cap as string
			Tilespane.controls[curTile].visible=true
		)
	)
)

	 	checkbutton pane_1 "-"	width: 24	enabled: false	offset:[20,15]	across:6
		checkbutton pane_2 "-"	width: 24 	enabled: false	offset:[10,15]
	 	checkbutton pane_3 "-" 	width: 24 	enabled: false	offset:[0,15]
	 	checkbutton pane_4 "-"	width: 24 	enabled: false	offset:[-10,15]
	 	checkbutton pane_5 "-" 	width: 24 	enabled: false	offset:[-20,15]
	 	checkbutton pane_6 "-" 	width: 24 	enabled: false	offset:[-30,15]
	 	checkbutton pane_7 "-" 	width: 24 	enabled: false	offset:[20,-5]	across:6
	 	checkbutton pane_8 "-"	width: 24	enabled: false	offset:[10,-5]
	 	checkbutton pane_9 "-"	width: 24	enabled: false	offset:[0,-5]
	 	checkbutton pane_10 "-" width: 24	enabled: false	offset:[-10,-5]
	 	checkbutton pane_11 "-"	width: 24	enabled: false	offset:[-20,-5]
	 	checkbutton pane_12 "-"	width: 24	enabled: false	offset:[-30,-5]
	 	checkbutton pane_13 "-"	width: 24	enabled: false	offset:[20,-5]	across:6
	 	checkbutton pane_14 "-"	width: 24	enabled: false	offset:[10,-5]
	 	checkbutton pane_15 "-"	width: 24	enabled: false	offset:[0,-5]
	 	checkbutton pane_16 "-"	width: 24	enabled: false	offset:[-10,-5]
	 	checkbutton pane_17 "-"	width: 24	enabled: false	offset:[-20,-5]
	 	checkbutton pane_18 "-"	width: 24	enabled: false	offset:[-30,-5]
	 	checkbutton pane_19 "-"	width: 24	enabled: false	offset:[20,-5]	across:6
	 	checkbutton pane_20 "-"	width: 24	enabled: false	offset:[10,-5]
	 	checkbutton pane_21 "-"	width: 24	enabled: false	offset:[0,-5]
	 	checkbutton pane_22 "-"	width: 24	enabled: false	offset:[-10,-5]
	 	checkbutton pane_23 "-"	width: 24	enabled: false	offset:[-20,-5]
	 	checkbutton pane_24 "-"	width: 24	enabled: false	offset:[-30,-5]
	 	checkbutton pane_25 "-"	width: 24	enabled: false	offset:[20,-5]	across:6
	 	checkbutton pane_26 "-"	width: 24	enabled: false	offset:[10,-5]
	 	checkbutton pane_27 "-"	width: 24	enabled: false	offset:[0,-5]
	 	checkbutton pane_28 "-"	width: 24	enabled: false	offset:[-10,-5]
	 	checkbutton pane_29 "-"	width: 24	enabled: false	offset:[-20,-5]
	 	checkbutton pane_30 "-"	width: 24	enabled: false	offset:[-30,-5]
	 	checkbutton pane_31 "-"	width: 24	enabled: false	offset:[20,-5]  across:6
	 	checkbutton pane_32 "-"	width: 24	enabled: false	offset:[10,-5]
	 	checkbutton pane_33 "-"	width: 24	enabled: false	offset:[0,-5]
	 	checkbutton pane_34 "-"	width: 24	enabled: false	offset:[-10,-5]
	 	checkbutton pane_35 "-"	width: 24	enabled: false	offset:[-20,-5]
	 	checkbutton pane_36 "-"	width: 24	enabled: false	offset:[-30,-5]
		
		label ly
		button tselectnone	"None" enabled: true across:2 width:50
		button tselectall	"All" enabled: true width:50

on tselectall pressed do (
	for i=1 to 36 do (
		Tilespane.controls[i].checked=true
	)
)

on tselectnone pressed do (
	for i=1 to 36 do (
		Tilespane.controls[i].checked=false
	)
)



)

rollout BigRender "Render settings" width:250 height:100 (

	group "Render settings" (
		radiobuttons splitcount "Tiles count:" labels:#("1","4","9","16","25","36") default:3
		label lx2
		spinner  rwidth   "Overall width: "   	type:#integer range:[0,65536,defWidth] enabled:false
		spinner  rheight  "Overall height: "      	type:#integer range:[0,65536,defHeight] enabled:false
		checkbox notcustom "Use scene settings" checked:true
		label lx1
		spinner  overlap "Pixel overlap:"	type:#integer

	)

	group "Rendering" (
		checkbox show "Show image while rendering" checked:true align:#left
	)
	
	on splitcount changed state do (
		Tilespane.updateButtonState(state)
	)

	group "BigRender v2.21" (
		button  doRender "Render"
	)

	on notcustom changed custom do (
		case custom of (
			true:
				(rwidth.enabled=false
				rheight.enabled=false
				initRenderValues())
			false:
				(rwidth.enabled=true
				rheight.enabled=true)
		)
	)


	on doRender pressed do (

		a = splitcount.state
		b = splitcount.state * splitcount.state

		w = rwidth.value  / a
		h = rheight.value / a			

		bm = bitmap w h
		--p = overlap.value - 1
	    p = overlap.value
		wasCancelled=false

		for i=0 to b-1 do (
			row = i / a
			col = i - floor(row) * a

			-- Skip all tiles pressed in Tilespane:
			tileNum=(row*6)+col+1
			if ((not wasCancelled) and (Tilespane.controls[tileNum].checked)) do (
				render cancelled:&wasCancelled renderType:#blowup region:#((w/a)*col,(h/a)*row,w/a*(col+1)+p,(h/a)*(row+1)+p) outputwidth:w outputheight:h outputfile:(defPath + "\\" + (row+1) as string + "-"+ ((col+1)as integer) as string + "_" + defFname) vfb:show.checked progressbar:show.checked to:bm
			)
		)
	format "Render done.\n"
	unDisplay bm
	)
)




-- create the rollout window and add the  rollout
if splitRenderFloater != undefined do
(
	closerolloutfloater splitRenderFloater
)
SplitRenderFloater = newRolloutFloater "Rakete BigRender" 250 650
addRollout BigRender SplitRenderFloater
addRollout Tilespane SplitRenderFloater


fn initRenderValues = (
	-- init values from render dialogue:
	defWidth=renderWidth
	defHeight=renderHeight
	defPath=pathConfig.removePathLeaf rendOutputFilename
	defFname=pathConfig.stripPathToLeaf rendOutputFilename

	format "Rendering to %\n" defPath
	format "Filename: %\n" defFname

	if BigRender.notcustom.checked do (
		BigRender.rwidth.value=defWidth
		BigRender.rheight.value=defHeight
	)
)

initRenderValues()
Tilespane.updateButtonState BigRender.splitcount.state
format "Init done.\n"


